package com.jz.dmp.modules.service.sys;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import com.jz.common.bean.BaseBeanResponse;
import com.jz.common.bean.BaseResponse;
import com.jz.common.bean.PageInfoResponse;
import com.jz.dmp.modules.controller.sys.bean.DmpRoleBatch;
import com.jz.dmp.modules.controller.sys.bean.DmpRoleDto;
import com.jz.dmp.modules.controller.sys.bean.DmpRoleRequest;
import com.jz.dmp.modules.model.DmpMember;
import com.jz.dmp.modules.model.DmpRole;

/**
 * 角色表服务接口
 * @author ybz
 *
 */
public interface DmpRoleService {

	/**条件查询所有角色表
	 * @param dmpRoleRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public PageInfoResponse<DmpRoleDto> findList(DmpRoleRequest dmpRoleRequest, HttpServletRequest httpRequest)throws Exception;
	

	/**新增角色表
	 * @param dmpRole
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpRole> add(DmpRole dmpRole, HttpServletRequest httpRequest)throws Exception;
	
	/**主键查询角色表
	 * @param dmpRoleRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpRoleDto> findById(DmpRoleRequest dmpRoleRequest, HttpServletRequest httpRequest)throws Exception;

	/**修改角色表
	 * @param dmpRole
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpRole> edit(DmpRole dmpRole, HttpServletRequest httpRequest)throws Exception;

	/**主键删除角色表
	 * @param dmpRoleRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse deleteById(DmpRoleRequest dmpRoleRequest, HttpServletRequest httpRequest)throws Exception;

	/**批量新增角色表
	 * @param dmpRoleVo
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpRoleBatch> addBatch(DmpRoleBatch dmpRoleBatch, HttpServletRequest httpRequest)throws Exception;


	/**  
	* @Title: findMemberRolesByUserId  
	* @Description: TODO(根据用户主键获取用户角色)  
	* @param @param userId
	* @param @return    参数  
	* @return List<DmpRole>    返回类型  
	* @throws  
	*/ 
	public List<DmpRole> findMemberRolesByUserId(Integer userId);


	/**  
	* @Title: findMemberProjRolesByUser  
	* @Description: TODO(获取用户默认项目的项目角色)  
	* @param @param userName
	* @param @return    参数  
	* @return List<DmpRole>    返回类型  
	* @throws  
	*/ 
	public List<DmpRole> findMemberProjRolesByUser(DmpMember user);

}
